#include "data.h"
int DataGrass;
int DataGrassLast;
int DataZookeeper;
int DataMom;
int DataDad;
int DataKid;
// animals
int DataAardvark;
int DataAnteater;
int DataBadger;
int DataBeaver;
int DataCat;
int DataChimpanzee;
int DataCow;
int DataDonkey;
int DataElephant;
int DataGiraffe;
int DataHippopotamus;
int DataLion;
int DataOpossum;
int DataPandabear;
int DataRat;
int DataSheep;
int DataTiger;
int DataWolf;
int DataZebra;
int DataDirt;
int DataWater;
int DataRoad;
int DataTree1;
int DataTree2;
int DataPortapot;
int DataVendingmachine;
int DataVendingmachineSnacks;
int DataWall;
int DataGate;
int DataZookeeperHut;
int DataReserved;
int DataZooplane;
int DataFragment;
int DataTrashcan;
int DataBench;
int DataGiftshop;
LandFont * small_font, * medium_font, * big_font;
static double _font_scale;
static int _reserve(Data * self);
static int _load(Data * self, str name);
static int _loadf(Data * self, str form, ...);
static int _load_tile(Data * self, str name);
int data_id_for_name(Data * self, str name) {
    for (int i = 1; i < self->count; i += 1) {
        if (land_equals(self->entry [i].name, name)) {
            return i;
        }
    }
    return 0;
}
str data_name_for_id(Data * self, int did) {
    return self->entry [did].name;
}
static int _reserve(Data * self) {
    int i = self->count;
    self->count++;
    if (self->count == 1000) {
        print("Error: out of ids!");
        return 0;
    }
    return i;
}
static int _load(Data * self, str name) {
    int i = _reserve(self);
    if (i == 0) {
        return 0;
    }
    int frame = 0;
    while (1) {
        char * path = land_strdup("out/");
        land_append(& path, "%s_%04d.png", name, ++frame);
        //auto pic = land_image_load(path)
        LandImage * pic = land_atlas_image_create(self->atlas, path);
        if (! pic || ! land_image_was_loaded(pic)) {
            if (pic) {
                land_image_destroy(pic);
            }
            if (frame == 1) {
                print("Error: could not load %s (%s)", name, path);
                abort();
            }
            frame--;
            break;
        }
        int w, h;
        if (land_atlas_image_original_size(self->atlas, path, & w, & h)) {
            pic->x += (int)(w / 2);
            pic->y += (int)(h / 2);
        }
        //land_image_center(pic)
        //land_image_auto_crop(pic)
        land_free(path);
        if (frame == 1) {
            self->entry [i].image = pic;
        }
        else {
            if (frame == 2) {
                self->entry [i].animation = land_animation_new(NULL);
                land_animation_add_frame(self->entry [i].animation, self->entry [i].image);
            }
            land_animation_add_frame(self->entry [i].animation, pic);
        }
    }
    self->entry [i].name = land_strdup(name);
    print("Loaded %s (%d frames)", name, frame);
    return i;
}
static int _loadf(Data * self, str form, ...) {
    char * name = land_strdup("");
    va_list args;
    va_start(args, form);
    land_appendv(& name, form, args);
    va_end(args);
    int tid = _load(self, name);
    land_free(name);
    return tid;
}
static int _load_tile(Data * self, str name) {
    int tid = _load(self, name);
    for (int i = 0; i < 8; i += 1) {
        _loadf(self, "%s_%d", name, 1 << i);
    }
    _loadf(self, "%s_not1", name);
    _loadf(self, "%s_not4", name);
    _loadf(self, "%s_not16", name);
    _loadf(self, "%s_not64", name);
    _loadf(self, "%s_not1-16", name);
    _loadf(self, "%s_not4-64", name);
    _loadf(self, "%s_255", name);
    return tid;
}
Data* data_load(void) {
    Data * self;
    land_alloc(self);
    self->count = 1;
    self->atlas = land_atlas_new("atlas.txt");
    DataGrass = _load(self, "iso-grass");
    _load(self, "iso-grass_1");
    _load(self, "iso-grass_2");
    _load(self, "iso-grass_3");
    _load(self, "iso-grass_4");
    _load(self, "iso-grass_5");
    _load(self, "iso-grass_6");
    _load(self, "iso-grass_7");
    _load(self, "iso-grass_8");
    _load(self, "iso-grass_9");
    _load(self, "iso-grass_10");
    DataGrassLast = _load(self, "iso-grass_11");
    DataZookeeper = _load(self, "zookeeper");
    //animals
    DataAardvark = _load(self, "aardvark");
    DataAnteater = _load(self, "anteater");
    DataBadger = _load(self, "badger");
    DataBeaver = _load(self, "beaver");
    DataCat = _load(self, "cat");
    DataChimpanzee = _load(self, "chimpanzee");
    DataCow = _load(self, "cow");
    DataDonkey = _load(self, "donkey");
    DataElephant = _load(self, "elephant");
    DataGiraffe = _load(self, "giraffe");
    DataHippopotamus = _load(self, "hippopotamus");
    DataOpossum = _load(self, "opossum");
    DataLion = _load(self, "lion");
    _load(self, "lion_male");
    DataPandabear = _load(self, "pandabear");
    DataRat = _load(self, "rat");
    DataSheep = _load(self, "sheep");
    DataTiger = _load(self, "tiger");
    DataWolf = _load(self, "wolf");
    DataZebra = _load(self, "zebra");
    DataWater = _load_tile(self, "iso-grass-water");
    DataDirt = _load_tile(self, "iso-grass-dirt");
    DataRoad = _load_tile(self, "iso-grass-road");
    DataTree1 = _load(self, "christmas tree");
    DataTree2 = _load(self, "birch");
    DataVendingmachine = _load(self, "vendingmachine");
    DataVendingmachineSnacks = _load(self, "vendingmachine_snacks");
    DataPortapot = _load(self, "portapot");
    _load(self, "portapot_occupied");
    DataZookeeperHut = _load(self, "zookeeperhut");
    DataReserved = _reserve(self);
    DataZooplane = _load(self, "zooplane");
    DataGiftshop = _load(self, "zoogiftshop");
    DataMom = _load(self, "sara_zoo");
    DataDad = _load(self, "joseph_zoo");
    DataKid = _load(self, "princess_child");
    DataWall = _load(self, "zoowall_1");
    _load(self, "zoowall_2");
    _load(self, "zoowall_4");
    _load(self, "zoowall_8");
    _load(self, "zoowall_16");
    _load(self, "zoowall_32");
    _load(self, "zoowall_64");
    _load(self, "zoowall_128");
    DataGate = _load(self, "zoowall_32_gate");
    DataFragment = _load(self, "iso-grass-fragment");
    DataTrashcan = _load(self, "zootrashcan");
    DataBench = _load(self, "zoobench");
    return self;
}
void data_reload_fonts(double scale) {
    if (small_font) {
        land_font_destroy(small_font);
    }
    if (medium_font) {
        land_font_destroy(medium_font);
    }
    if (big_font) {
        land_font_destroy(big_font);
    }
    _font_scale = scale;
    small_font = land_font_load("URWGothicBook.ttf", 18 * _font_scale);
    medium_font = land_font_load("URWGothicBook.ttf", 32 * _font_scale);
    big_font = land_font_load("URWGothicBook.ttf", 48 * _font_scale);
}
void data_font_scale(bool on) {
    double s = on ? 1.0 / _font_scale : 1.0;
    land_font_scale(big_font, s);
    land_font_scale(medium_font, s);
    land_font_scale(small_font, s);
}
