#ifndef _MAP_
#define _MAP_
typedef struct Tile Tile;
typedef struct Map Map;
typedef struct Tag Tag;
#include "main.h"
#include "draw.h"
#include "data.h"
#include "actor.h"
enum {
    FlagWater=1,
    FlagDirt=2,
    FlagRoad=4,
    FlagGrass=8
};
struct Tile {
    int tid;
    int flags;
    int actors [4];
    int oid;
    int draw_level;
    int h;
    int visible /* 0 = dark, 255 = fully visible */;
};
struct Map {
    LandMap * map;
    LandGrid * grid;
    Tile * tiles;
    int w, h;
    int ax, ay, aw, ah;
    int entrance_x, entrance_y;
};
struct Tag {
    float x, y;
    float r, g, b, a;
    char text [100];
    int until_ts;
};
Tile* map_get(int x, int y);
void map_place_object(int x, int y, int oid);
int tile_count_actors(Tile * tile);
bool map_remove_actor(Tile * tile, int aid);
bool map_add_actor(Tile * tile, int aid);
void fixup(int x, int y);
Map* map_new(int w, int h);
void map_create(void);
void map_add_debug_stuff(void);
void map_del(Map * (* self_p));
void map_get_under_mouse(float mx, float my, float * tx, float * ty);
void map_place_water(int x, int y);
void map_toggle(int x, int y, int flag);
void map_place(int x, int y, int flag, int s);
void map_harvest(int x, int y, int s);
void map_enclosure(int x, int y, int s);
float map_visibility(int x, int y);
void map_assign(int w, int h);
bool map_is_reserved(int x, int y, int w, int h);
bool map_is_assigned(int x, int y, int w, int h);
void map_road(int x, int y, int w, int h);
void tag_new(float x, float y, float r, float g, float b, int duration, str text, ...);
void tags_tick(void);
#endif
