#include "ui.h"
void ui_draw(void) {
    int gs = 0;
    if (game->place == DataGrass || game->place == DataRoad || game->place == DataWater) {
        gs = 2;
    }
    else if (game->place == DataDirt) {
        gs = 5;
    }
    else if (game->place == DataZookeeper || game->place == DataGiftshop) {
        gs = 2;
    }
    else if (game->place) {
        gs = 1;
    }
    if (gs > 0) {
        float xm, ym;
        int sx = game->sx;
        int sy = game->sy;
        int i1 = - (int)(gs / 2);
        int i2 = i1 + gs;
        int j1 = - (int)(gs / 2);
        int j2 = j1 + gs;
        land_grid_get_cell_position(game->map->grid, game->view, sx, sy, & xm, & ym);
        for (int j = j1; j < j2; j += 1) {
            for (int i = i1; i < i2; i += 1) {
                Tile * t = map_get(sx + i, sy + j);
                if (map_is_assigned(sx + i, sy + j, 1, 1) && ! map_is_reserved(sx + i, sy + j, 1, 1)) {
                    land_color_set(land_color_name("citron"));
                }
                else {
                    land_color_set(land_color_name("crimson"));
                }
                float xs = game->view->scale_x;
                float ys = game->view->scale_y;
                float h = t->draw_level * 20;
                land_thickness(2 * xs);
                float x = xm * xs + 32 * xs * i - 32 * xs * j;
                float y = ym * ys + 16 * ys * i + 16 * ys * j;
                land_line(x, y - h * xs, x + 32 * xs, y + 16 * xs - h * xs);
                land_line(x, y - h * ys, x - 32 * ys, y + 16 * ys - h * ys);
                if (i == i2 - 1) {
                    float x2 = x + 32 * xs;
                    float y2 = y + 16 * ys;
                    land_line(x2, y2 - h * xs, x2 - 32 * ys, y2 + 16 * xs - h * ys);
                }
                if (j == j2 - 1) {
                    float x2 = x - 32 * xs;
                    float y2 = y + 16 * ys;
                    land_line(x2, y2 - h * xs, x2 + 32 * ys, y2 + 16 * xs - h * ys);
                }
            }
        }
    }
}
