#ifndef _ZOO_
#define _ZOO_
typedef struct Zoo Zoo;
typedef struct ZooAnimal ZooAnimal;
typedef struct ZooViewpoint ZooViewpoint;
#include "land/land.h"
#include "main.h"
#include "game.h"
#include "actor.h"
#define DAYS 100
struct Zoo {
    char name [40];
    int species_count [DAYS];
    int animal_count [DAYS];
    int hungry_count [DAYS];
    int visitor_count [DAYS];
    int visitor_thirsty [DAYS];
    int visitor_hungry [DAYS];
    int visitor_toilet [DAYS];
    int visitors_killed [DAYS];
    int popularity [DAYS];
    int trash [DAYS];
    int exhaustion [DAYS];
    int died [DAYS];
    int expenses [DAYS];
    int sales [DAYS];
    int t;
    LandHash * known_animals;
    int vp_count;
    LandArray * viewpoints;
    LandHash * current_species_set;
    LandArray * current_animals;
    int current_visitors;
    int max_capacity;
    int max_level;
    int need_popularity_for_levelup;
};
struct ZooAnimal {
    char name [40];
    int cost;
    int did;
    int killer /* 0, 1, 2, 3 */;
    int prey /* only if prey < killer */;
};
struct ZooViewpoint {
    int x, y;
    int distance /* form entrance */;
    int order;
};
extern Zoo * zoo;
bool zoo_is_visitor(int aid);
ZooAnimal* zoo_add_animal(str name, int did, int cost);
void zoo_init(void);
bool zoo_is_animal(int did);
void zoo_plan_visit(void);
int zoo_need_popularity(void);
void zoo_assign_for_level(void);
bool zoo_level_up(void);
void visitor_new(void);
int zoo_visit(int n, int * x, int * y);
int zoo_cost(int did);
int zoo_buy(int did);
int zoo_is_killer(int cid);
int zoo_is_prey(int cid);
Actor* zoo_get_hungry_animal(int x, int y, int r, int shuffle);
void zoo_visitor_satisfaction(bool thirsty, bool hungry, bool toilet, int popularity);
void zoo_budget(int diff);
#endif
